#ifndef _SAMURIZE_INCLUDE_
#define _SAMURIZE_INCLUDE_

#define SAMURIZE_PLUGIN_CHAR  extern "C" __declspec(dllexport) char* __stdcall
#define SAMURIZE_PLUGIN_INT   extern "C" __declspec(dllexport) int __stdcall

//static HWND hSamurize;

//=======================================
// 1: Source plugin
// 2: Visual plugin
// 4: Input plugin
const int WM_SAM_SOURCEPLUGIN = 1;
const int WM_SAM_VISUALPLUGIN = 2;
const int WM_SAM_INPUTPLUGIN = 4;

enum InfoType {
   PLUGIN_NAME = 0,
   PLUGIN_AUTHOR = 1,
   PLUGIN_VERSION = 2,
   PLUGIN_CREATED = 3,
   PLUGIN_UPDATED = 4,
   PLUGIN_WEBSITE = 5,
   PLUGIN_EMAIL = 6
};

// Messages note that some messages do not apply to all clients
// (eg. the taskbar client has no tray icon)

//=======================================
// Actions

// tells Samurize to reload
const int WM_SAM_RELOAD_CONFIG            = 40000;

// sets pause (use wparam=0 for unpause, 1 for pause)
const int WM_SAM_PAUSE                    = 40001;

// sets Samurize visible (use wparam=0 for hide, 1 for show)
const int WM_SAM_SHOW                     = 40002;

// set tray icon visibility (use wparam=0 for hide, 1 for show)
const int WM_SAM_SHOWTRAYICON             = 40003;

// exits Samurize
const int WM_SAM_EXIT                     = 40004;

// sets client settings according to wparam (see below), 0=false, 1=true
const int WM_SAM_SET_CLIENTSETTING        = 40005;

// sets client behaviour (use wparam, 0=on top, 1=pinned, 2=normal,
// 3=abs. on top)
const int WM_SAM_SET_CLIENTPOSITION       = 40006;

// pass a pointer to a string as lparam - tells Samurize to load that
// config file. (eg. "myconfig.ini")
const int WM_SAM_LOAD_CONFIGFILE          = 40007;

// set the client refresh rate using wparam
const int WM_SAM_SET_REFRESHINTERVAL      = 40008;

// opens the config editor with the currently loaded config
const int WM_SAM_EDITCONFIGFILE           = 40009;

// toggles Samurize's pause status, returns the new status (1=paused,
// 0=unpaused)
const int WM_SAM_TOGGLE_PAUSE             = 40010;

// toggles Samurize's visible status, returns the new status
// (1=visible, 0=hidden)
const int WM_SAM_TOGGLE_SHOW              = 40011;

// toggles Samurize's tray icon visible status, returns the new status
// (1=visible, 0=hidden)
const int WM_SAM_TOGGLE_SHOWTRAYICON      = 40012;

// toggles Samurize's client settings according to wparam (see below),
// returns the new status (1=true, 0=false)
const int WM_SAM_TOGGLE_CLIENTSETTING     = 40013;

// sets Samurize XML output (use wparam=0 for disable, 1 for enable)
const int WM_SAM_SERVER_XML_OUTPUT        = 40017;

// sets Samurize PNG output (use wparam=0 for disable, 1 for enable)
const int WM_SAM_SERVER_PNG_OUTPUT        = 40018;

// Information strings

// returns pointer to string containing instance name
const int WM_SAM_GET_INSTANCENAME         = 40020;

// returns pointer to string containing config file name
const int WM_SAM_GET_CONFIGNAME           = 40021;

// returns pointer to string containing full path to config file
const int WM_SAM_GET_CONFIGPATH           = 40022;

// returns pointer to name of language file
const int WM_SAM_GET_LANGUAGEFILE         = 40023;

//=======================================
// integers

// gets client behaviour (use wparam, 0=on top, 1=pinned, 2=normal,
// 3=abs. on top)
const int WM_SAM_GET_CLIENTPOSITION       = 40050;

// gets client settings according to wparam (see below), 0=false, 1=true
const int WM_SAM_GET_CLIENTSETTING        = 40051;

// returns client refresh rate
const int WM_SAM_GET_REFRESHINTERVAL      = 40052;

// booleans, returns 0 for false, 1 for true
const int WM_SAM_IS_PAUSED                = 40080;
const int WM_SAM_IS_VISIBLE               = 40081;
const int WM_SAM_IS_TRAYICONVISIBLE       = 40082;

// sending data(external apps) using WM_COPYDATA
// tells Samurize to load a config
const int SAM_LOAD_CONFIG             = 1000;

// wparams for use with WM_SAM_GET_CLIENTSETTING & WM_SAM_SET_CLIENTSETTING
const int SAM_CLIENT_LOCKED           = 2000;
const int SAM_CLIENT_CLICKTHRU        = 2001;
const int SAM_CLIENT_USEDESIGNPOS     = 2002;
const int SAM_CLIENT_SNAP             = 2003;
const int SAM_CLIENT_SNAPTOCLIENTS    = 2004;


#endif // _SAMURIZE_INCLUDE_
